﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;

public partial class WebDataGrid_Sample : System.Web.UI.Page
{
	
    protected void Page_Load(object sender, EventArgs e)
    {
				
		this.WebDataGrid1.DataSource = this.CreateDataSource2();					
		this.WebDataGrid1.DataBind();
		
		DropDownProvider p = this.WebDataGrid1.EditorProviders["WebDataGrid1_DropDownProvider1"] as DropDownProvider;
	    for (int i = 0; i < 7; i++)
	    {
			DropDownItem d = new DropDownItem(i.ToString());
			p.EditorControl.Items.Add(new DropDownItem(i.ToString(), i.ToString()));
		}
    }

	    
    private DataSet CreateDataSource()
    {
		DataSet data = new DataSet();

		DataTable person = new DataTable("Person");
		person.Columns.Add("Id", typeof(int));
		person.Columns.Add("Name", typeof(string));
		person.PrimaryKey = new DataColumn[] { person.Columns["Id"] };

		person.Rows.Add(1, "John");
		person.Rows.Add(2, "Ivan");
		person.Rows.Add(3, "Marry");

		data.Tables.Add(person);
		return data;
	}
	
	private DataTable CreateDataSource2()
	{
		DataTable dt = new DataTable();

		dt.Columns.Add("Column 1", typeof(int));
		dt.Columns.Add("Column 2", typeof(DateTime));
		dt.Columns.Add("Column 3", typeof(string));
		dt.Columns.Add("Column 4", typeof(bool));
		dt.Columns.Add("Column 5", typeof(int));

		dt.Columns.Add("Column 6", typeof(string));
		dt.Columns.Add("Column 7", typeof(bool));
		dt.Columns.Add("Column 8", typeof(int));

		DataColumn[] primary = { dt.Columns[0] };
		dt.PrimaryKey = primary;
		DateTime starter = DateTime.Today.AddYears(-1);
		for (int i = 0; i < 6; i++)
		{
			DataRow dr = dt.NewRow();
			dr[0] = i + 100;
			dr[1] = starter.AddDays(i); //DateTime.Today.AddDays(i);
			if (i == 2)
				dr[2] = "really long and horrible text that will force column to wrap ";
			else
				dr[2] = "Test AND " + i.ToString();
			dr[3] = (i % 2 == 0) ? 1 : 0;
			dr[4] = i;

			dr[5] = i;
			dr[6] = i;
			dr[7] = i;
			dt.Rows.Add(dr);
		}
		return dt;

	}

	protected void WebDataGrid1_RowUpdating(object sender, RowUpdatingEventArgs e)
	{
		/* This event is going to raised right before the updates are commited to the database*/
		
		//The row to wich the updates are going to be made
		GridRecord row = e.Row; 
		// This is the row ID (which will be the primary key or the DataKeyField that you set up on the grid)
		// and the index of the row
		IDPair id = e.RowID;
		
		//you can loop through all the cells to see what the value of each cell currently is
		for (int i=0; i<row.Items.Count; i++)
		{
			object value =row.Items[i].Value;
			string text = row.Items[i].Text;
			
			// if you need to u can also tell which column the cell belongs to			
			GridField field = row.Items[i].Column;

			// from the RowUpdatingEventArgs you can tell what the new value of  the 
			// cell is going to be once it is changes, by accessing the Values collection
			// with the column key
			object newValue = e.Values[field.Key];
			
			/* Instead of looping from the cells you could have also looped through the grid's 
			 Columns collection and for each column looked at the OldValue for that column (which is 
			 basicly what the value is before it is updated)*/
			object oldValue = e.OldValues[field.Key];
		}
		/* You can cancel this event and prevent any changes from occuring to your data, this way
		 If you cancel the event then the RowUpdated will not be raised*/
		e.Cancel = true;	
		 
		
	}
	protected void WebDataGrid1_RowUpdated(object sender, RowUpdatedEventArgs e)
	{
		/* This event is going to raised after the updates are commited to the database*/
		
		// This is the row ID of the row that was updated(which will be the primary key or the DataKeyField that you set up on the grid)
		// and the index of the row
		IDPair id = e.RowID;
		
		/* So this is event is mostly to inform you that the action has occured, if you need
		 * to you can get the updated row this way*/		
		 GridRecord row = this.WebDataGrid1.Rows.FromIDPair(id);
		
	}
}
